"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileDuration = void 0;
const time_1 = require("./time");
function getFileDuration(file) {
    return new Promise((resolve) => {
        let url = URL.createObjectURL(file);
        let audioElement = new Audio(url);
        audioElement.addEventListener('loadedmetadata', _event => {
            resolve({
                duration: audioElement.duration,
                durationStr: time_1.secondsFormat(audioElement.duration)
            });
        });
    });
}
exports.getFileDuration = getFileDuration;
