import { LinkedTreeNode } from './linkedTree';
export declare function insert<T>(tree: LinkedTreeNode<T>, target: LinkedTreeNode<T>): void;
export declare function setFirst<T>(tree: LinkedTreeNode<T>, target: LinkedTreeNode<T>): void;
export declare function setLast<T>(tree: LinkedTreeNode<T>, target: LinkedTreeNode<T>): void;
export declare function setBefore<T>(source: LinkedTreeNode<T>, target: LinkedTreeNode<T>): void;
export declare function setAfter<T>(tree: LinkedTreeNode<T>, target: LinkedTreeNode<T>): void;
export declare function cutLinked<T>(tree: LinkedTreeNode<T>, afterSibling?: LinkedTreeNode<T>): LinkedTreeNode<T>[];
export declare function remove<T>(tree: LinkedTreeNode<T>): LinkedTreeNode<T> | undefined;
export declare function destroy<T>(tree: LinkedTreeNode<T>): void;
export declare type LoopHandleResult<T = any> = {
    parent?: T;
    prev?: T;
    break?: boolean;
    [key: string]: any;
};
export declare function loopDFS<T>(tree: LinkedTreeNode<T>, handle: (current: LinkedTreeNode<T>, parentResult?: LoopHandleResult) => any, handleResult?: LoopHandleResult): void;
export declare function loopDFSTail<T>(tree: LinkedTreeNode<T>, handle: (current: LinkedTreeNode<T>, childrenResults: LoopHandleResult[]) => any): any;
export declare function bubble<T>(tree: LinkedTreeNode<T>, handle: (current: LinkedTreeNode<T>) => boolean | void): boolean;
